<template>
  <div id="echarts-world-map" ref="chartContainer"></div>
</template>

<script setup lang="ts">
import { watchEffect, ref } from 'vue';
import * as echarts from 'echarts';
import { toTitleCase, } from '@/chartPrep';

const chartContainer = ref<HTMLElement | null>(null);
const countryData = ref([]);
const worldData: any = ref([]);
const metric = ref('');

const props = defineProps<{
  worldMapData: any;
  countryData: any;
  metric: string
  filterData: any;
}>();

function load() {

  echarts.registerMap('world', worldData.value);

  // find the min and max values for the metric
  const min = Math.min(...countryData.value.map((country: any) => country[metric.value]));
  const max = Math.max(...countryData.value.map((country: any) => country[metric.value]));

  // filter the data to only include countries with data in filterData
  countryData.value = countryData.value.filter((country: any) => props.filterData.includes(country.country_name));

  if (chartContainer.value) {
    const chart = echarts.init(chartContainer.value);

    const chartOptions: echarts.EChartsOption = {
      tooltip: {
        trigger: 'item',
        formatter: (params: any) => {
          const countryName = params.name;
          const countryDataItem = countryData.value.find((country: any) => country.country_name == countryName);
          const customData = countryDataItem ? countryDataItem[metric.value] : 0;
          const metricDescription = toTitleCase(metric.value);

          return `${countryName} - ${metricDescription} ${customData}`;
        },
      },

      visualMap: {
        min: min,
        max: max,
        text: ['Max', 'Min'],
        realtime: true,
        calculable: true,
        precision: 0,
        inRange: {
          color: ['#d94e5d', '#ed9e3e', '#eac736', '#a3cbe6', '#7bb6dd', '#50a3ba'],
        },
      },
      series: [
        {
          name: 'World Map',
          type: 'map',
          map: 'world',
          roam: 'zoom',
          itemStyle: {
            borderColor: '#111',
          },
          scaleLimit: {
            min: 1,
            max: 7,
          },
          emphasis: {
            itemStyle: {
              areaColor: '#2a333d',
            },
          },
          data: countryData.value.map((country: any) => ({
            name: country.country_name,
            value: country[metric.value],
          })),
        },
      ],
    };

    chart.setOption(chartOptions);
  }
};

watchEffect(() => {
  metric.value = props.metric;
  countryData.value = props.countryData;
  worldData.value = props.worldMapData;
  load();
});

</script>

<style scoped lang="scss">
@import '@/scss/chart';
</style>
